<?php
	/*
		spfetch - ver.2013.10.24
		Boltzsoft Technologies - Makoto ITANI
		http://www.boltzsoft.com/tool/spfetch
		
		▼機能
		POP3サーバからメールを受信して、IMAP4サーバへコピー
	
		▼使用ライブラリ
		PEARライブラリを使用していますので、別途入手して下さい
		・POP3
		・IMAP/IMAPProtocol

		▼問題点
		・IMAPの投入先ラベルにASCII文字以外を利用する場合、IMAPProtocol.php の修正が必要
		・アドレス帳の名前が反映されない
		
		▼更新履歴
		・ver.2013.10.12 → 2013.10.24: POP3のメールがある場合のみ、IMAP4へ接続に変更
	*/

	mb_internal_encoding('utf-8');
	require_once('Net/POP3.php');
	require_once('Net/IMAP.php');
	require_once('Net/IMAPProtocol.php');

	// デフォルト値 (POSTがあれば、そっちを使う)
	// メール取得元POP3サーバ
	$sp_user    = '';
	$sp_pass    = '';
	$sp_pop3    = 'mail.spmode.ne.jp';
	$sp_port    = 995;
	$sp_msg_del = false; // POPサーバからメールを削除(する:true しない:false)

	// メール保存先IMAPサーバ
	$gm_user  = '';
	$gm_pass  = '';
	$gm_label = 'INBOX'; // ASCII文字以外を利用する場合 IMAPProtocol.php を修正
	$gm_imap  = 'imap.gmail.com';
	$gm_port  = 993;

?><html>
<head>
	<meta http-equiv="content-type" content="text/html; charset=utf-8" />
	<meta name="robots" content="noindex, nofollow" />
</head>
<body>
<?php
	// 値がPOSTされていれば利用
	$sp_user    = get_post_key($sp_user, 'sp_user');
	$sp_pass    = get_post_key($sp_pass, 'sp_pass');
	$sp_pop3    = get_post_key($sp_pop3, 'sp_pop3');
	$sp_port    = get_post_key($sp_port, 'sp_port');
	$sp_msg_del = get_post_key($sp_msg_del, 'sp_msg_del');

	$gm_user  = get_post_key($gm_user, 'gm_user');
	$gm_pass  = get_post_key($gm_pass, 'gm_pass');
	$gm_label = get_post_key($gm_label, 'gm_label');
	$gm_imap  = get_post_key($gm_imap, 'gm_imap');
	$gm_port  = get_post_key($gm_port, 'gm_port');

	// POP3接続
	$pop3 = new Net_POP3();
	if( $pop3->connect("ssl://$sp_pop3", $sp_port) ){
		if ( $pop3->login($sp_user, $sp_pass) ){
			$msg_count = $pop3->numMsg();
			if( ($msg_count !== FALSE) && ($msg_count > 0) ){ // メールがあれば
				// IMAP4 接続
				$imap = new Net_IMAP($gm_imap, $gm_port);
				if( PEAR::isError($imap) ){
						echo 'error imap: connect(' . $imap->getMessage() . ').';
				}else{
					if( PEAR::isError($ret = $imap->login($gm_user, $gm_pass)) ){
						echo 'error imap: login(' . $ret->getMessage() . ').';
					}else{
						$gm_label_utf7imap = mb_convert_encoding($gm_label, 'UTF7-IMAP', 'UTF-8');
						if( $imap->mailboxExist($gm_label_utf7imap) ){

							// メール転送
							for( $msg_id = 1;  $msg_id <= $msg_count; $msg_id++ ){ 
								echo "$msg_id: ";
								$eml = $pop3->getMsg($msg_id);
								if( PEAR::isError($rtn = $imap->appendMessage($eml, $gm_label_utf7imap)) ){
									echo 'error imap: append(' . $ret->getMessage() . ').';
								}else{
									$header_list = $pop3->getParsedHeaders($msg_id);
									echo mb_decode_mimeheader($header_list['Subject']) . "<br />\r\n";
									if( $sp_msg_del ){
										$pop3->deleteMsg($msg_id);
									}
								}
							}
						}else{
							echo "error imap: not exists($gm_label)";
						}
					}
					$imap->disconnect();
				}
			}else{
				echo 'msg: msg none || pop3 login error.';
			}
		}else{
			echo 'error pop3: login.';
		}
		$pop3->disconnect();
	}else{
		echo 'error pop3: connect.';
	}

function get_post_key($def_value, $post_key){
	if( array_key_exists($post_key, $_POST) ){
		return $_POST[$post_key];
	}else{
		return $def_value;
	}
}
?>
</body></html>